/* zf10r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__10 = 10;

/* Subroutine */ int zf10r_c(R_fp f, real *a, real *b, real *eps,
        integer *ndig, integer *itmax, real *root, integer *ierr)
{
    /* Initialized data */

    static real zero = 0.f;
    static real half = .5f;
    static real one = 1.f;
    static real three = 3.f;
    static real ten = 10.f;
    static real sys051 = 1.192093e-7f;
    static integer ndmax = 6;

    /* System generated locals */
    integer i__1;
    real r__1, r__2;

    /* Builtin functions */
    double pow_ri(real *, integer *);

    /* Local variables */
    static integer nsig;
    static real rone, temp, c__, d__, e, p, q, r__, s, t, a1, b1;
    extern /* Subroutine */ int utzf10_c(integer *, integer *);
    static real fa, fb, fc;
    static integer io;
    static real rm, fbc, tol;

    a1 = *a;
    b1 = *b;
    nsig = *ndig;
    io = 0;
    *ierr = 0;
    if (*ndig == 0) {
        nsig = ndmax;
    }
    i__1 = -nsig;
    t = (real)pow_ri(&ten, &i__1);
    fa = (real)(*f)(a);
    fb = (real)(*f)(b);
    if ((r__1 = fa * fb) < 0.f) {
        goto L1;
    } else if (r__1 == 0) {
        goto L19;
    } else {
        goto L20;
    }
L1:
    c__ = *a;
    fc = fa;
    d__ = *b - *a;
    e = d__;
L2:
    if (abs(fc) >= abs(fb)) {
        goto L3;
    }
    *a = *b;
    *b = c__;
    c__ = *a;
    fa = fb;
    fb = fc;
    fc = fa;
L3:
/* Computing MAX */
    r__1 = t, r__2 = (sys051 + sys051) * abs(*b);
    tol = max(r__1,r__2);
    if (abs(fb) <= abs(*eps)) {
        goto L16;
    }
    rm = (c__ - *b) * half;
    if (abs(rm) >= tol) {
        goto L4;
    }
    goto L16;
L4:
    if (abs(e) < tol || abs(fa) <= abs(fb)) {
        goto L12;
    }
    s = fb / fa;
    if (*a - c__ != 0.f) {
        goto L6;
    } else {
        goto L5;
    }
L5:
    p = (rm + rm) * s;
    q = one - s;
    goto L7;
L6:
    q = fa / fc;
    r__ = fb / fc;
    rone = r__ - one;
    p = s * ((rm + rm) * q * (q - r__) - (*b - *a) * rone);
    q = (q - one) * rone * (s - one);
L7:
    if (p - zero <= 0.f) {
        goto L8;
    } else {
        goto L9;
    }
L8:
    p = -p;
    goto L10;
L9:
    q = -q;
L10:
    s = e;
    e = d__;
    if (p + p >= three * rm * q - (r__1 = tol * q, abs(r__1)) && p >= (r__2 = 
            half * s * q, abs(r__2))) {
        goto L11;
    }
    d__ = p / q;
    goto L13;
L11:
    e = rm;
    d__ = e;
    goto L13;
L12:
    e = rm;
    d__ = e;
L13:
    *a = *b;
    fa = fb;
    if (abs(d__) > tol) {
        goto L14;
    }
    temp = -tol;
    if (rm > zero) {
        temp = tol;
    }
    goto L15;
L14:
    temp = d__;
L15:
    ++io;
    if (io <= *itmax) {
        goto L18;
    }
    *ierr = 65;
L16:
    *itmax = io;
    if (*ierr != 0) {
        goto L21;
    }
L17:
    *root = *b;
    *b = b1;
    *a = a1;
    goto L22;
L18:
    *b += temp;
    fb = (real)(*f)(b);
    fbc = fb * fc;
    if (fbc <= 0.f) {
        goto L2;
    } else {
        goto L1;
    }
L19:
    if (fa == zero) {
        *b = *a;
    }
    goto L16;
L20:
    *ierr = 66;
    io = 1;
    goto L16;
L21:
    utzf10_c(ierr, &c__10);
    goto L17;
L22:
    return 0;
} /* zf10r_c */
